<?xml version='1.0' encoding='UTF-8' ?>
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                template="../../templates/generalCU.xhtml">


    <ui:define name="title">.::Sistema Nacional Catastral::. .::Gestión de la solicitud::.</ui:define>
    <ui:define name="content">
        <p:ajaxStatus onstart="statusDialog.show();"
                      onsuccess="statusDialog.hide();" onerror="statusDialog.hide();"/>

        <p:focus />


        <h:panelGrid columns="1" width="100%">
            <p:messages id="msgsGS" showDetail="false" globalOnly="false" />
            <h:form prependId="false">

                <h:panelGrid columns="2" width="100%">
                    <p:panel header="Buscar solicitud en correspondencia">
                        <h:panelGrid columns="3">
                            <h:panelGroup>
                                <h:outputLabel value="Nro. solicitud: "
                                               styleClass="outputLabelStyle" for="numeroSolicitudBusqueda" />
                                <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                            </h:panelGroup>
                            <h:inputText value="#{gestionarSolicitud.numeroSolicitud}"
                                         required="true" id="numeroSolicitudBusqueda"
                                         label="Nro. solicitud" />
                            <p:commandButton value="Buscar" icon="ui-icon-search"
                                             action="#{gestionarSolicitud.buscarSolicitud}"
                                             ajax="true" update="msgsGS, formSolicitud" />
                        </h:panelGrid>
                    </p:panel>
                    <p:panel header="Opciones">
                        <div align="right">
                            <h:panelGrid columns="3">
                                <p:commandButton value="Nueva solicitud"
                                                 icon="ui-icon-document"
                                                 action="#{gestionarSolicitud.nuevaSolicitud}"
                                                 update="msgsGS, btnGuardar, btnGuardar, espacio, datosBasicos, 
                                                 origen, destino, tipoDocumentoCorrespondencia, nuevoTramite, 
                                                 limpiarPredios, adicionarTramite, eliminarDocumentacionAdicional, 
                                                 editarDocumentacionAdicional, nuevoDocumentoAdicional, eliminarDocumentacion, 
                                                 editarDocumentacion"
                                                 immediate="true" ajax="false" />
                                <p:commandButton value="Seleccionar predios"
                                                 icon="ui-icon-home"
                                                 action="#{gestionarSolicitud.seleccionarPredios}" ajax="true"
                                                 immediate="true" oncomplete="consultaPredio.show();" />
                                <p:commandButton value="Buscar Solicitud con Filtros"
                                                 icon="ui-icon-search" ajax="true" immediate="true" 
                                                 oncomplete="busquedaFiltradaWV.show();" />
                            </h:panelGrid>
                        </div>
                    </p:panel>
                </h:panelGrid>
            </h:form>
            <h:form prependId="false" rendered="#{gestionarSolicitud.editando}" 
                    id="formSolicitud">
                <!-- p:panel header="Datos Básicos" toggleable="true" toggleSpeed="500" widgetVar="panel" id="datosBasicos" -->

                <p:fieldset legend="Datos básicos" toggleable="true"
                            toggleSpeed="500" id="datosBasicos"
                            collapsed="#{gestionarSolicitud.datosBasicosCerrado}">
                    <ui:include src="datosBasicosSolicitud.xhtml" />
                </p:fieldset>

                <p:spacer width="0" height="10"/>

                <p:fieldset legend="Solicitantes" toggleable="true" toggleSpeed="500"
                            id="solicitantesFS"
                            collapsed="#{gestionarSolicitud.origenCerrado}">

                    <ui:include src="resumenSolicitantes.xhtml"/>

                </p:fieldset>

                <p:spacer width="0" height="10"/>

                <p:fieldset legend="Envío" toggleable="true" toggleSpeed="500"
                            id="envioFS"
                            collapsed="#{gestionarSolicitud.origenCerrado}">

                    <p:panel header="Datos de envío">
                        <h:panelGrid columns="4">
                            <h:outputLabel value="Sistema envío: " for="sistemaEnvio"
                                           styleClass="outputLabelStyle" />
                            <h:selectOneMenu id="sistemaEnvio"
                                             value="#{gestionarSolicitud.solicitud.sistemaEnvio}"
                                             disabled="#{gestionarSolicitud.solicitud.id ne null}">
                                <f:selectItems value="#{gestionarSolicitud.sistemasEnvio}" />
                            </h:selectOneMenu>

                            <h:outputLabel value="Número guía: " for="numeroGuia"
                                           styleClass="outputLabelStyle" />
                            <h:inputText id="numeroGuia"
                                         value="#{gestionarSolicitud.solicitud.numeroGuia}"
                                         maxlength="20" 
                                         disabled="#{gestionarSolicitud.solicitud.id ne null}"/>

                        </h:panelGrid>
                    </p:panel>
                </p:fieldset>

                <p:spacer width="0" height="10"/>

                <center> 
                    <p:commandButton value="Guardar solicitud" icon="ui-icon-circle-check" 
                                     disabled="#{gestionarSolicitud.solicitud.id ne null}"
                                     oncomplete="solicitudConfirmationWV.show()"
                                     process="@form"/> 
                </center>

                <p:spacer width="0" height="10"/>

                <p:panel rendered="false">
                    <p:fieldset legend="Avisos" toggleable="true" toggleSpeed="500"
                                rendered="#{gestionarSolicitud.solicitud != null
                                            and gestionarSolicitud.solicitud.numero != null}">
                        <ui:include src="manejoAvisosDeMutacion.xhtml" />
                    </p:fieldset>
                </p:panel>

                <p:spacer width="0" height="10"/>


                <p:fieldset legend="Destino" toggleable="true" toggleSpeed="500"
                            id="destino" widgetVar="destino"
                            collapsed="#{gestionarSolicitud.destinoCerrado}" rendered="false">

                    <h:panelGrid columns="6" width="100%" border="0">

                        <h:outputLabel value="Territorial: " for="destinoTerritorialId"
                                       styleClass="outputLabelStyle" />
                        <h:panelGrid columns="3">
                            <h:selectOneMenu id="destinoTerritorialId"
                                             value="#{gestionarSolicitud.solicitud.destinoTerritorialId}"
                                             disabled="#{!gestionarSolicitud.editando}">
                                <f:selectItems value="#{gestionarSolicitud.territoriales}"></f:selectItems>
                                <p:ajax immediate="true" update="destinoDependenciaId"></p:ajax>
                            </h:selectOneMenu>

                            <p:commandLink
                                update="btnOrdenTerritoriales, destinoTerritorialId"
                                title="Orden" ajax="true" immediate="true"
                                action="#{gestionarSolicitud.cambiarOrdenTerritoriales}"
                                id="btnOrdenTerritoriales"
                                disabled="#{!gestionarSolicitud.editando}">
                                <p:graphicImage
                                    rendered="#{gestionarSolicitud.ordenTerritoriales eq 'NOMBRE'}"
                                    value="/images/sortCode.png" />
                                <p:graphicImage
                                    rendered="#{gestionarSolicitud.ordenTerritoriales eq 'CODIGO'}"
                                    value="/images/sortText.png" />

                            </p:commandLink>
                        </h:panelGrid>

                        <h:outputLabel value="Dependencia: " for="destinoDependenciaId"
                                       styleClass="outputLabelStyle" />
                        <h:selectOneMenu id="destinoDependenciaId"
                                         value="#{gestionarSolicitud.solicitud.destinoDependenciaId}"
                                         disabled="#{!gestionarSolicitud.editando}">
                            <f:selectItems value="#{gestionarSolicitud.dependencias}"></f:selectItems>
                        </h:selectOneMenu>

                        <h:outputLabel value="Funcionario: " for="destinoFuncionarioId"
                                       styleClass="outputLabelStyle" />
                        <h:selectOneMenu id="destinoFuncionarioId"
                                         value="#{gestionarSolicitud.solicitud.destinoFuncionarioId}"
                                         disabled="#{!gestionarSolicitud.editando}">
                            <f:selectItems value="#{gestionarSolicitud.funcionarios}"></f:selectItems>
                        </h:selectOneMenu>

                    </h:panelGrid>
                </p:fieldset>

                <p:spacer width="0" height="10"/>

                <p:fieldset legend="Trámite seleccionado" toggleable="true"
                            toggleSpeed="500" widgetVar="tramiteWV"
                            collapsed="#{gestionarSolicitud.tramiteCerrado}"
                            rendered="#{gestionarSolicitud.solicitud.numero != null}">

                    <ui:include src="tramiteSeleccionadoSolicitud.xhtml"/>
                </p:fieldset>

                <p:spacer height="10"></p:spacer>
                <div align="center">
                    <h:panelGrid columns="3" rendered="#{gestionarSolicitud.solicitud.numero ne null}">
                        <p:commandButton value="Nuevo trámite" icon="ui-icon-document"
                                         action="#{gestionarSolicitud.crearTramite}" id="nuevoTramite"
                                         update="fuente, tipoTramite, claseMutacion, subtipo, tipoInscripcion, fundamentoPeticion, tblPredios"
                                         oncomplete="if(tramiteWV.cfg.collapsed) tramiteWV.toggle()" disabled="#{!gestionarSolicitud.editando}"
                                         immediate="true"/>
                        <p:commandButton value="Limpiar predios seleccionados" id="limpiarPredios"
                                         action="#{gestionarSolicitud.limpiarPrediosTramite}"
                                         icon="ui-icon-arrowreturnthick-1-w" update="tblPredios" disabled="#{!gestionarSolicitud.editando}"
                                         immediate="true"></p:commandButton>
                        <p:commandButton value="Adicionar trámite a la solicitud" id="adicionarTramite"
                                         icon="ui-icon-plus" disabled="#{!gestionarSolicitud.editando}"
                                         action="#{gestionarSolicitud.adicionarTramite}"
                                         update="tblTramitesWV, reqSubtipoTramite,
                                         msgsTramite" immediate="true"
                                         oncomplete="if(fsTramitesWV.cfg.collapsed) fsTramitesWV.toggle()"/>
                    </h:panelGrid>
                </div>

                <p:spacer width="0" height="10"/>

                <p:fieldset legend="Trámites de la solicitud" toggleable="true"
                            toggleSpeed="500" id="tramites"  
                            collapsed="#{gestionarSolicitud.tramitesCerrado}"
                            widgetVar="fsTramitesWV"
                            rendered="#{gestionarSolicitud.solicitud.numero != null}">

                    <ui:include src="tablaTramitesSolicitud.xhtml"/>


                </p:fieldset>

                <p:fieldset legend="Trámites rechazados de la solicitud de aviso" toggleable="true"
                            toggleSpeed="500" id="tramitesRechazadosFS"
                            widgetVar="fsTramitesRechazadosWV"
                            rendered="#{gestionarSolicitud.solicitud.numero != null}">
                    <p:spacer height="10" width="1"/>
                    <ui:include src="tablaTramitesRechazadosAvisoSolicitud.xhtml"/>
                </p:fieldset>

                <div align="center">
                    <h:panelGrid columns="9" rendered="#{gestionarSolicitud.solicitud.numero != null}">

                        <p:commandButton
                            value="#{gestionarSolicitud.editando?'Guardar':'Modificar'}"
                            disabled="#{!gestionarSolicitud.existe and !gestionarSolicitud.editando}"
                            action="#{gestionarSolicitud.crearActualizarSolicitud}"
                            icon="ui-icon ui-icon-disk"
                            update="datosBasicos, origen, destino, btnTramites, btnAvisos, btnProductos"
                            id="btnGuardar" ajax="false" />
                        <p:spacer id="espacio" width="15" />
                        <p:commandButton value="Productos" id="btnProductos"
                                         icon="ui-icon-cart"
                                         disabled="#{!gestionarSolicitud.existe or !gestionarSolicitud.editando}" />
                        <p:spacer width="15" />
                        <p:commandButton value="Avisos de Mutación" id="btnAvisos"
                                         icon="ui-icon-clock"
                                         disabled="#{!gestionarSolicitud.existe or !gestionarSolicitud.editando}" />
                        <p:spacer width="15" />
                        <p:commandButton value="Imprimir" icon="ui-icon-print" disabled="#{!gestionarSolicitud.existe}"/>
                        <p:spacer width="15" />
                        <p:commandButton value="Cerrar" icon="ui-icon-close"
                                         action="index" ajax="false" immediate="true" id="btnCerrar"/>

                    </h:panelGrid>
                </div>
            </h:form>
        </h:panelGrid>

        <p:dialog header="Consulta de predio" widgetVar="consultaPredio"
                  modal="true" id="consultaPredio"
                  appendToBody="true" resizable="true" position="center" width="1024"
                  height="550">
            <ui:include src="../../conservacion/consultaPredio.xhtml" />
        </p:dialog>

        <p:dialog header="Busqueda Filtrada" widgetVar="busquedaFiltradaWV"
                  modal="true" id="busquedaFiltrada"
                  appendToBody="true" resizable="true" position="center" width="1024"
                  height="550">
            <ui:include src="buscarSolicitud.xhtml" />
        </p:dialog>

        <p:dialog header="Documentación" widgetVar="documentacionWV"
                  resizable="true" id="documentacion" width="700" showEffect="fade"
                  height="620" maximizable="true" hideEffect="explode" modal="true"
                  appendToBody="true" >
            <ui:include src="documentacionTramite.xhtml"></ui:include>
        </p:dialog>

        <p:dialog header="Predios del aviso rechazado" widgetVar="prediosAvisoRechazadoWV"
                  resizable="true" id="prediosAvisoRechazadoDialog" width="700" showEffect="fade"
                  height="500" maximizable="true" hideEffect="explode" modal="true"
                  appendToBody="true" >
            <ui:include src="tablaPrediosAvisoRechazado.xhtml" />
        </p:dialog>


        <p:confirmDialog
            message="Está seguro de eliminar el documento soporte?" width="200"
            header="Confirmación"
            severity="alert" widgetVar="confirmacionWV">
            <h:form>
                <p:commandButton value="Si" update="cars"
                                 actionListener="#{gestionarSolicitud.eliminarDocumento}"
                                 oncomplete="confirmacionWV.hide()" />
                <p:commandButton value="No" onclick="confirmacionWV.hide()"
                                 type="button" />
            </h:form>
        </p:confirmDialog>

        <p:confirmDialog appendToBody="true"
                         message="¿Está seguro que desea generar la solicitud?" width="200"
                         header="Confirmación"
                         severity="alert" widgetVar="solicitudConfirmationWV">
            <h:form>
                <p:commandButton value="Si" update="msgsGS, formSolicitud"
                                 actionListener="#{gestionarSolicitud.crearActualizarSolicitud}"
                                 oncomplete="solicitudConfirmationWV.hide()"/>
                <p:commandButton value="No" onclick="solicitudConfirmationWV.hide()"
                                 type="button" />
            </h:form>
        </p:confirmDialog>

        <p:dialog header="Adicionar solicitante" widgetVar="addSolicitanteDialogWV"
                  id="addSolicitanteDialog" width="960" height="640" appendToBody="true" modal="true">
            <ui:include src="solicitanteSolicitud.xhtml"/>
        </p:dialog>

        <p:confirmDialog appendToBody="true"
                         message="¿Está seguro que desea eliminar el solicitante de la lista?" width="200"
                         header="Confirmación"
                         severity="alert" widgetVar="eliminarSolicitanteConfirmationWV">
            <h:form>
                <p:commandButton value="Si" update="solicitanteSolicitudTable"
                                 actionListener="#{gestionarSolicitud.eliminarSolicitanteDeLista}"
                                 oncomplete="eliminarSolicitanteConfirmationWV.hide()" />
                <p:commandButton value="No" onclick="eliminarSolicitanteConfirmationWV.hide()"
                                 type="button" />
            </h:form>
        </p:confirmDialog>


    </ui:define>

</ui:composition>